Index: trunk/packages/vizservers/nanovis/VolumeRenderer.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/VolumeRenderer.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/VolumeRenderer.cpp	(revision 1429)
@@ -89,4 +89,35 @@
 }
 
+/*
+ * FIXME:  This is a good example of the wrong data structures being used.
+ *	   The volumes should be in a list not a vector.  Each list
+ *	   element should contain pointers to both the volume and the
+ *	   transfer function.  The shouldn't be parallel vectors.  
+ * 
+ *	   And there shouldn't be one vector for "all" volumes and another
+ *	   for those being rendered, unless you work to keep them in sync.  
+ *	   Use one master list instead.
+ */
+void
+VolumeRenderer::remove_volume(size_t volIndex)
+{
+    vector<Volume *>::iterator vIter;
+    vector<TransferFunction *>::iterator tfIter;
+
+    assert(volIndex < volume.size());
+    assert(volIndex < tf.size());
+
+    vIter = volume.begin();
+    tfIter = tf.begin();
+    size_t i;
+    for (i = 0; i < volIndex; i++) {
+	tfIter++;
+	vIter++;
+    }
+    volume.erase(vIter);
+    tf.erase(tfIter);
+    n_volumes--;
+}
+
 void
 VolumeRenderer::shade_volume(Volume* _vol, TransferFunction* _tf)
@@ -177,4 +208,7 @@
 
     for(int vol_index = 0; vol_index< num_volumes; vol_index++) {
+	cur_vol = NULL;
+	cur_tf = NULL;
+#ifdef notdef
         if (vol_index != n_volumes) {
             cur_vol = volume[vol_index];
@@ -184,10 +218,15 @@
             cur_tf = ani_tf;
         }
-    
+#else
+	cur_vol = volume[vol_index];
+	cur_tf = tf[vol_index];
+#endif
+
         polys[vol_index] = NULL;
         actual_slices[vol_index] = 0;
 
-        if(!cur_vol->is_enabled())
+        if(!cur_vol->is_enabled()) {
             continue; //skip this volume
+	}
 
         int n_slices = cur_vol->get_n_slice();
Index: trunk/packages/vizservers/nanovis/VolumeRenderer.h
===================================================================
--- trunk/packages/vizservers/nanovis/VolumeRenderer.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/VolumeRenderer.h	(revision 1429)
@@ -106,4 +106,5 @@
 
     int add_volume(Volume* _vol, TransferFunction* _tf); 
+    void remove_volume(size_t volIndex); 
     // add a volume and its transfer function
     // we require a transfer function when a 
Index: trunk/packages/vizservers/nanovis/config.h
===================================================================
--- trunk/packages/vizservers/nanovis/config.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/config.h	(revision 1429)
@@ -31,5 +31,5 @@
 #define PROTOTYPE		1
 
-//#define NEW_FLOW_ENGINE
+#define NEW_FLOW_ENGINE		1
 
 /* 
Index: trunk/packages/vizservers/nanovis/dxReader.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/dxReader.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/dxReader.cpp	(revision 1429)
@@ -162,8 +162,9 @@
     }
     return new Rappture::Unirect3d(x0, x0 + dx * nx, nx, y0, y0 + dy * ny, ny,
-				   z0, z0 + dz * nz, nz, nValues, values);
+				   z0, z0 + dz * nz, nz, nValues, values, 3);
 }
 
 
+#ifdef notdef
 /*
  * Load a 3D vector field from a dx-format file
@@ -363,4 +364,5 @@
     return true;
 }
+#endif
 
 /* Load a 3D volume from a dx-format file
@@ -744,5 +746,4 @@
     while (!fin.eof()) {
         fin.getline(line, sizeof(line) - 1);
-	fprintf(stderr, "line is %s\n", line);
         if (fin.fail()) {
             result.error("error in data stream");
@@ -840,6 +841,4 @@
         }
     }
-    fprintf(stderr, "found nx=%d ny=%d, nz=%d, x0=%f, y0=%f, z0=%f\n",
-	    nx, ny, nz, x0, y0, z0);
     // read data points
     if (fin.eof()) {
@@ -869,6 +868,4 @@
 		int nindex = iz*nx*ny + iy*nx + ix;
 		field.define(nindex, dval[p]);
-		fprintf(stderr,"nindex = %i\tdval[%i] = %lg\n", nindex, p,
-                        dval[p]);
 		fflush(stderr);
 		nread++;
@@ -1177,5 +1174,4 @@
     while (!fin.eof()) {
         fin.getline(line, sizeof(line) - 1);
-	fprintf(stderr, "line is %s\n", line);
         if (fin.fail()) {
 	    result.addError("line \"%s\"error in data stream");
@@ -1273,6 +1269,4 @@
     }
 
-    fprintf(stderr, "found nx=%d ny=%d, nz=%d, x0=%f, y0=%f, z0=%f\n",
-	    nx, ny, nz, x0, y0, z0);
     // read data points
     if (fin.eof()) {
Index: trunk/packages/vizservers/nanovis/nanovis.cpp
===================================================================
--- trunk/packages/vizservers/nanovis/nanovis.cpp	(revision 1428)
+++ trunk/packages/vizservers/nanovis/nanovis.cpp	(revision 1429)
@@ -69,4 +69,8 @@
 #include <R2/R2Fonts.h>
 
+#include "Unirect.h"
+#include "Switch.h"
+#include "FlowCmd.h"
+
 #define SIZEOF_BMP_HEADER   54
 
@@ -126,13 +130,7 @@
 FILE *NanoVis::recfile = NULL;
 
-bool NanoVis::lic_on = false;
-bool NanoVis::particle_on = false;
-bool NanoVis::vector_on = false;
 bool NanoVis::axis_on = true;
 bool NanoVis::config_pending = false;
 bool NanoVis::debug_flag = false;
-bool NanoVis::lic_slice_x_visible = false;
-bool NanoVis::lic_slice_y_visible = false;
-bool NanoVis::lic_slice_z_visible = false;
 
 Tcl_Interp *NanoVis::interp;
@@ -427,15 +425,18 @@
     int result;
 
+#ifdef notdef
     if (NanoVis::debug_flag) {
         fprintf(stderr, "in ExecuteCommand(%s)\n", Tcl_DStringValue(dsPtr));
     }
-
+#endif
     gettimeofday(&tv, NULL);
     start = CVT2SECS(tv);
 
+#ifdef notdef
     if (NanoVis::logfile != NULL) {
         fprintf(NanoVis::logfile, "%s", Tcl_DStringValue(dsPtr));
         fflush(NanoVis::logfile);
     }
+#endif
     if (NanoVis::recfile != NULL) {
         fprintf(NanoVis::recfile, "%s", Tcl_DStringValue(dsPtr));
@@ -450,7 +451,9 @@
     stats.cmdTime += finish - start;
     stats.nCommands++;
+#ifdef notdef
     if (NanoVis::debug_flag) {
         fprintf(stderr, "leaving ExecuteCommand status=%d\n", result);
     }
+#endif
     return result;
 }
@@ -506,4 +509,5 @@
     volume[index] = new Volume(0.f, 0.f, 0.f, width, height, depth, 1.,
 			       n_component, data, vmin, vmax, nzero_min);
+    fprintf(stderr, "VOLINDEX=%d, n_volumes=%d\n", index, n_volumes);
     return volume[index];
 }
@@ -665,6 +669,6 @@
     }
     
-    if (screen_buffer) {
-        delete[] screen_buffer;
+    if (screen_buffer != NULL) {
+        delete [] screen_buffer;
         screen_buffer = NULL;
     }
@@ -827,7 +831,7 @@
 
 
-#if PROTOTYPE
-    licRenderer = new NvLIC(NMESH, NPIX, NPIX, lic_axis, Vector3(lic_slice_x, lic_slice_y, lic_slice_z), g_context);
-#endif
+    licRenderer = new NvLIC(NMESH, NPIX, NPIX, lic_axis, 
+			    Vector3(lic_slice_x, lic_slice_y, lic_slice_z), 
+			    g_context);
 
     ImageLoaderFactory::getInstance()->addLoaderImpl("bmp", new BMPImageLoaderImpl());
@@ -835,5 +839,7 @@
     grid->setFont(fonts);
 
+#ifdef notdef
     pointset_renderer = new PointSetRenderer();
+#endif
 }
 
@@ -1041,5 +1047,5 @@
             sprintf(filename, "/tmp/flow_animation/image%03d.bmp", frame_number);
 
-        printf("Writing %s\n", filename);
+        fprintf(stderr, "Writing %s\n", filename);
         f = fopen(filename, "wb");
         if (f == 0) {
@@ -1052,9 +1058,10 @@
         }
     }
-    ssize_t nWritten;
-    nWritten = fwrite(header, SIZEOF_BMP_HEADER, 1, f);
-    assert(nWritten == SIZEOF_BMP_HEADER);
-    nWritten = fwrite(screen_buffer, (3*win_width+pad)*win_height, 1, f);
-    assert(nWritten == (3*win_width+pad)*win_height);
+    if (fwrite(header, SIZEOF_BMP_HEADER, 1, f) != 1) {
+	Trace("can't write header: short write\n");
+    }
+    if (fwrite(screen_buffer, (3*win_width+pad)*win_height, 1, f) != 1) {
+	Trace("can't write data: short write\n");
+    }
     fclose(f);
 }
@@ -1633,4 +1640,8 @@
         fprintf(stderr, "in display\n");
     }
+
+    if (FlowCmd::flags & FlowCmd::MAP_PENDING) {
+	FlowCmd::MapFlows();
+    }
     //assert(glGetError()==0);
     if (HeightMap::update_pending) {
@@ -1701,8 +1712,13 @@
         if ((licRenderer != NULL) && (licRenderer->isActivated())) {
             licRenderer->render();
-        }
-
+	    /*FlowCmd::SetupFlows();*/
+        }
+#ifdef notdef
         if ((flowVisRenderer != NULL) && (flowVisRenderer->isActivated())) {
             flowVisRenderer->render();
+	}
+#endif
+	if (FlowCmd::flags & FlowCmd::REDRAW_PENDING) {
+	    FlowCmd::RenderFlows();
 	}
 
@@ -1732,9 +1748,9 @@
         perf->disable();
     }
-
     perf->reset();
     if (debug_flag) {
         fprintf(stderr, "leaving display\n");
     }
+
 
 }
@@ -1923,6 +1939,6 @@
 		break;
 	case '5' :
-		{
-			printf("vector field deleted (vf_name2)\n");
+86		{
+a			printf("vector field deleted (vf_name2)\n");
 			NanoVis::flowVisRenderer->removeVectorField("vf_name2");
 		}
@@ -2063,9 +2079,8 @@
     int status = TCL_OK;
 
-    //
     //  Read and execute as many commands as we can from stdin...
-    //
+
     bool isComplete = false;
-    while (status == TCL_OK) {
+    while ((!feof(NanoVis::stdin)) && (status == TCL_OK)) {
         //
         //  Read the next command from the buffer.  First time through we
@@ -2088,5 +2103,5 @@
                     break;
                 }
-                DoExit(0);
+		DoExit(100);
             }
             ch = (char)c;
@@ -2103,5 +2118,4 @@
             break;
         }
-
         if (isComplete) {
             // back to original flags during command evaluation...
@@ -2167,5 +2181,5 @@
 #endif
     if (feof(NanoVis::stdin)) {
-        DoExit(0);
+        DoExit(90);
     }
     if (debug_flag) {
@@ -2336,5 +2350,5 @@
 
     glutMainLoop();
-    DoExit(0);
+    DoExit(80);
 }
 
Index: trunk/packages/vizservers/nanovis/nanovis.h
===================================================================
--- trunk/packages/vizservers/nanovis/nanovis.h	(revision 1428)
+++ trunk/packages/vizservers/nanovis/nanovis.h	(revision 1429)
@@ -137,7 +137,4 @@
     static float lic_slice_y;
     static float lic_slice_z;
-    static bool lic_slice_x_visible;
-    static bool lic_slice_y_visible;
-    static bool lic_slice_z_visible;
     static int lic_axis;	/* 0:x, 1:y, 2:z */
 
@@ -149,7 +146,4 @@
 
     static bool debug_flag;
-    static bool lic_on;
-    static bool particle_on;
-    static bool vector_on;
 
     static Tcl_Interp *interp;
